#ifndef UCIPARSER_H
#define UCIPARSER_H

#include <iostream>
#include <vector>
#include <string>

/*!
 * manages the communication with a UCI connection
 */
class UciParser
{
public:
    UciParser(void) = default;
    virtual ~UciParser(void) = default;

    virtual int parse(std::istream& in, std::ostream& out);

    virtual int executeLine(const std::string& line);
    virtual int executeCommand(const std::string& command,
                               const std::vector<std::string>& args);
};

#endif // UCIPARSER_H
