#include <iostream>
#include "UciParser.h"
#include "ChessGame.h"
#include "MoveGeneration.h"

using namespace std;
using namespace chessy;

auto main(int argc, char** argv) -> int
{
    ChessGame cg;
    string line;
    getline(cin, line);
    try {
        cg.loadFromFen(line);
        cout << cg.generateFen() << endl;
        PawnPushGenerator<BLACK_SIDE> mg{ cg };
        for (auto push : mg) {
            cout << "pawn: " << push.asString() << endl;
        }
        PositionSet knights = cg.getBoard().getBlackKnights();
        for (auto knight : knights) {
            for (auto pos : KnightMoveGenerator{ knight, cg.getBoard().getBlacks() }) {
                cout << "knight: " << Move(knight, pos).asString() << endl;
            }
        }
    }
    catch (runtime_error& re) {
        cerr << re.what() << endl;
        return 1;
    }
    cin.get();
    return 0;
    UciParser uciParser;
    uciParser.parse(cin, cout);
    return 0;
}
